-- spotlight.love

local gr, mg, ky, tm, ev	= love.graphics, love.image, love.keyboard, love.timer, love.event

function love.load()
	gr.setCaption( "Pixel Effect Lighting" )
	image = gr.newImage( 'MyTest1.jpg' )
	load_effect()
	loc, dia = { 0.5, 0.5 }, 1.0
	effect:send( 'dia', dia )
	effect:send( 'pos', loc )
	end

function love.draw()
	gr.setColor( 255, 255, 255, 255 )
	gr.setPixelEffect( effect )
		gr.draw( image )
		gr.setPixelEffect( )
	gr.setColor( 255, 255, 0, 255 )
	gr.print( 'fps: '..tm.getFPS( ), 10,  520 )
	gr.print( 'spot diameter: '..dia, 10, 540 )
	gr.print( 'move spotlight with arrow keys', 10, 560 )
	gr.print( 'change spot diameter with <s> & <d> keys', 10, 580 )
	end

function love.update(dt)
	if ky.isDown( 'down' )	then loc[2] = loc[2]<1	and loc[2]+dt	or 1.0	effect:send( 'pos', loc ) end
	if ky.isDown( 'up' )	then loc[2] = loc[2]>0	and loc[2]-dt	or 0.0	effect:send( 'pos', loc ) end
	if ky.isDown('right')	then loc[1] = loc[1]<1	and loc[1]+dt	or 1.0	effect:send( 'pos', loc ) end
	if ky.isDown('left')	then loc[1] = loc[1]>0	and loc[1]-dt	or 0.0	effect:send( 'pos', loc ) end
	if ky.isDown('d') 		then dia = dia < 3.0	and dia + dt	or 3,0	effect:send( 'dia', dia ) end
	if ky.isDown('s') 		then dia = dia > 0.1	and dia - dt	or 0.1	effect:send( 'dia', dia ) end
	end

function love.keypressed( key )
	if key == 'escape'	then ev.push( 'quit' )	end
	end

function load_effect()
	effect = love.graphics.newPixelEffect
		[[
		extern float dia;
		extern vec2 pos;
		vec4 effect(vec4 color, Image texture, vec2 tc, vec2 pixel_coords)
		{
			vec4 pixel	= Texel( texture, tc );
			float d2 	= clamp(dia,0,10);
			float root	= sqrt((pos[0]-tc.x)*(pos[0]-tc.x)+(pos[1]-tc.y)*(pos[1]-tc.y))/d2;
			pixel.r		= pixel.r - root;
			pixel.g		= pixel.g - root;
			pixel.b		= pixel.b - root;
			if (pixel.a > 0.0 ) { pixel.a = 1 - root; }
			return  pixel;
			}
		]]
	end
